/**************************************************
 * dltest
 *
 **************************************************
 * This code was created by Peter Harvey @ CodeByDesign.
 * Released under GPL 31.JAN.99
 *
 * Contributions from...
 * -----------------------------------------------
 * Peter Harvey		- pharvey@codebydesign.com
 **************************************************/
#include <stdio.h>
#include <dlfcn.h>

char *szSyntax =
"\n" \
"**********************************************\n" \
"* unixODBC - dltest                          *\n" \
"**********************************************\n" \
"* Syntax                                     *\n" \
"*                                            *\n" \
"*      dltest libName Symbol Flag            *\n" \
"*                                            *\n" \
"* libName                                    *\n" \
"*                                            *\n" \
"*      Full path + file name of share to test*\n" \
"*                                            *\n" \
"* Symbol                                     *\n" \
"*                                            *\n" \
"*      ie a function name in the share       *\n" \
"*                                            *\n" \
"* Flag                                       *\n" \
"*                                            *\n" \
"*      1 = strict , 2 = loose                *\n" \
"*                                            *\n" \
"* Notes                                      *\n" \
"*                                            *\n" \
"*      This can be placed into a makefile    *\n" \
"*      to throw an error if test fails.      *\n" \
"*                                            *\n" \
"* Examples                                   *\n" \
"*                                            *\n" \
"*      dltest /usr/lib/libMy.so MyFunc 1     *\n" \
"*                                            *\n" \
"* Please visit;                              *\n" \
"*                                            *\n" \
"*      http://www.genix.net/unixODBC         *\n" \
"*      pharvey@codebydesign.com              *\n" \
"**********************************************\n\n";													;

int main( int argc, char *argv[] )
{
	void	*hDLL;
	void	(*pFunc)();
	char	*pError;

	if ( argc != 4  )
	{
		printf( szSyntax );
		exit( 1 );
	}

	if ( *(argv[3]) == '1' )
	{
		printf( "INFO: Using RTLD_NOW\n" );
		hDLL = dlopen( argv[1], RTLD_NOW );

	}
	else
	{
		printf( "INFO: Using RTLD_LAZY\n" );
		hDLL = dlopen( argv[1], RTLD_LAZY );
	}

	if ( !hDLL )
	{
		printf( "[dltest] ERROR: %s\n", dlerror() );
		exit( 1 );
	}
	printf( "SUCCESS: Loaded %s\n", argv[1] );
	if ( argc > 1 )
	{
		pFunc = dlsym( hDLL, argv[2] );
		if ( (pError = dlerror()) != NULL )
		{
			printf( "ERROR: %s\n Could not find %s\n", pError, argv[2] );
			exit( 1 );
		}
		printf( "SUCCESS: Found %s\n", argv[2] );
	}
	dlclose( hDLL );
	return ( 0 );
}

